<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym

	Шаблон по умолчанию для админки модуля новостей
	Рекомендуется скопировать этот файл в templates/[шаблон админки]/Classes/[имя этого файла] и там уже начинать править.
	В случае если такой файл уже существует - правьте его.
*/
class TPLAdminNews
{

	/*
		Страница отображения всех тегов
		$items - массив статических страниц. Формат: ID=>array(), ключи внутреннего массива:
			language - язык тега
			name - название тега
			news - количество новостей у данного тега
			_aedit - ссылка на редактирование тега
			_adel - ссылка на удаление тега
		$cnt - количество тегов всего
		$pp - количество тегов на страницу
		$qs - массив параметров адресной строки для каждого запроса
		$page - номер текущей страницы, на которой мы сейчас находимся
		$links - перечень необходимых ссылок, массив с ключами:
			sort_name - ссылка на сортировку списка $items имени тега (возрастанию/убыванию в зависимости от текущей сортировки)
			sort_news - ссылка на сортировку списка $items количеству новостей (возрастанию/убыванию в зависимости от текущей сортировки)
			sort_id - ссылка на сортировку списка $items по ID (возрастанию/убыванию в зависимости от текущей сортировки)
			form_items - ссылка для параметра action формы, внтури которой происходит отображение перечня $items
			pp - фукнция-генератор ссылок на изменение количества тегов отображаемых на странице
			first_page - ссылка на первую страницу пагинатора
			pages - функция-генератор ссылок на остальные страницы
	*/
	public static function TagsList($items,$cnt,$pp,$qs,$page,$links)
	{

	}

	/*
		Страница добавления/редактирования тега
		$id - идентификатор редактируемого тега, если $id==0 значит тег добавляется
		$controls - перечень контролов в соответствии с классом контролов. Если какой-то элемент массива не является массивом, значит это заголовок подгруппы контролов
		$values - результирующий HTML код контролов, который необходимо вывести на странице. Ключи данного массива совпадают с ключами $controls
		$errors - массив ошибок
		$back - URL возврата
		$hasdraft - признак наличия черновика
		$links - перечень необходимых ссылок, массив с ключами:
			delete - ссылка на удаление категории или false
			nodraft - ссылка на правку/добавление категории без использования черновика или false
			draft - ссылка на сохранение черновиков (для фоновых запросов)
	*/
	public static function AddEditTag($id,$controls,$values,$errors,$back,$hasdraft,$links)
	{

	}

	/*
		Страница отображения всех новостей
		$items - массив новостей. Формат: ID=>array(), ключи внутреннего массива:
			cats - массив ID категорий, к которым принадлежит данная новость
			date - дата публикации новости
			enddate - дата завершения показа новости
			author - имя автора новости, беспасный HTML
			author_id - ID автора новости
			status - статус активности новости: 0 - не активна, 1 - активна, -1 - ожидает модерации, -2 - ожидает наступления даты активации, 2 - закреплена
			title - название новости
			_aedit - ссылка на редактирование новости
			_adel - ссылка на удаление новости
			_aswap - ссылка на обращение активности новости, если равна false - значит ссылка недоступна (частный случай)
		$categs - массив категорий новости. Форма: ID=>array(), ключи внутреннего массива:
			title - название категории
		$cnt - количество тегов всего
		$pp - количество тегов на страницу
		$qs - массив параметров адресной строки для каждого запроса
		$page - номер текущей страницы, на которой мы сейчас находимся
		$links - перечень необходимых ссылок, массив с ключами:
			sort_title - ссылка на сортировку списка $items по названию (возрастанию/убыванию в зависимости от текущей сортировки)
			sort_date - ссылка на сортировку списка $items по дате (возрастанию/убыванию в зависимости от текущей сортировки)
			sort_author - ссылка на сортировку списка $items по автору (возрастанию/убыванию в зависимости от текущей сортировки)
			sort_id - ссылка на сортировку списка $items по ID (возрастанию/убыванию в зависимости от текущей сортировки)
			form_items - ссылка для параметра action формы, внтури которой происходит отображение перечня $items
			pp - фукнция-генератор ссылок на изменение количества новостей отображаемых на странице
			first_page - ссылка на первую страницу пагинатора
			pages - функция-генератор ссылок на остальные страницы
	*/
	public static function ShowList($items,$categs,$cnt,$pp,$qs,$page,$links)
	{

	}

	/*
		Страница добавления/редактирования новости
		$id - идентификатор редактируемой новости, если $id==0 значит новость добавляется
		$values - массив значений полей
			Общие ключи:
			cats - массив категорий
			date  - дата публикации новости
			pinned - дата до наступления которой, новость будет закреплена
			enddate - завершение показов новости
			author - имя автора новости
			author_id - ID автора новости
			show_detail - флаг включения показа ссылки "подробнее" при отсутствии подробностей новости
			show_sokr - флаг включения отображения показа сокращенной новости при просмотре подробной
			reads - количество просмотров новости
			status - статус активности новости: 0 - не активна, 1 - активна, -1 - ожидает модерации

			Языковые ключи:
			title - заголовок новости
			announcement - анонс новости
			text - текст новости
			uri - URI новости
			meta_title - заголовок окна браузера при просмотре новости
			meta_descr - мета описание новости

			Особые языковые ключи:
			tags - теги новости

			Специальные ключи:
			_onelang - флаг моноязычной новости при включенной мультиязычности
			_maincat - идентификатор основной категории новости
		$errors - массив ошибок
		$uploader - интерфейс загрузчика
		$voting - интерфейс опросника
		$bypost - признак того, что данные нужно брать POST запроса
		$hasdraft - признак наличия черновика
		$back - URL возврата
		$links - перечень необходимых ссылок, массив с ключами:
			delete - ссылка на удаление категории или false
			nodraft - ссылка на правку/добавление категории без использования черновика или false
			draft - ссылка на сохранение черновиков (для фоновых запросов)
	*/
	public static function AddEdit($id,$values,$errors,$uploader,$voting,$bypost,$hasdraft,$back,$links)
	{

	}

	/*
		Страница удаления новости
		$a - массив параметров удаляемой новосоти
			title - новости
		$back - URL возврата
	*/
	public static function Delete($a,$back)
	{

	}

	/*
		Страница удаления тега
		$a - массив параметров удаляемого тега
			name - тег
		$back - URL возврата
	*/
	public static function DeleteTag($a,$back)
	{

	}

	/*
		Обертка для категорий
		$c - интерфейс категорий
	*/
	public static function Categories($c)
	{

	}

	/*
		Обертка для настроек
		$c - интерфейс настроек
	*/
	public static function Options($c)
	{

	}
}