<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym

	Шаблон по умолчанию для пользователей модуля новости.
	Рекомендуется скопировать этот файл в templates/[шаблон пользовательской части]/Classes/[имя этого файла] и там уже начинать править.
	В случае если такой файл уже существует - правьте его.
*/
class TplUserNews
{
	/*
		Список новостей на главной сайта и главной модуля
		$data - массив данных. Ключи:
			items - массив новостей. Формат: id=>array()
				date - дата публикации новости
				author - имя автора новости
				author_id - идентификатор автора новости
				status - статус новости (1 - активна, 0 - заблокирована, -1 - ожидает модерации)
				reads - число просмотров
				comments - число комментариев
				tags - массив идентификаторов тегов новости
				title - заголовок новости
				announcement - анонс новости
				voting - флаг наличия опроса в новости
				r_sum - сумма всех оценок
				r_total - число оценок
				r_average - средняя оценка

				_aedit - ссылка на редактирование новости, либо false
				_adel - ссылка на удаление новости, либо false
				_cat - идентификатор категории новости
				_readmore - флаг наличия подробной новости
				_hastext - флаг наличия подробного текста новости
				_url - ссылка на новость
				_canrate - флаг возможности оценивать новость
			cats - массив категорий. Формат: id=>array()
				_a - ссылка на категорию
				t - название категории
			tags - массив тегов. Формат: id=>array(), ключи внутреннего массива:
				_url - ссылка на новости с тегом
				name - имя тега
				cnt - количество новостей с данным тегом
		$cnt - количество новостей всего
		$page - номер страницы, на которой мы сейчас находимся
		$pp - число новостей на страницу
		$links - массив ссылок, ключи:
			first_page - ссылка на первую страницу пагинатора
			pages - функция-генератор ссылок на остальные страницы
	*/
	public static function ShowList($data,$cnt,$page,$pages,$pp,$links)
	{

	}

	/*
		Страница вывода новостей за определенную дату
		$data - дата
		$links - массив ссылок, ключи:
			first_page - ссылка на первую страницу пагинатора
			pages - функция-генератор ссылок на остальные страницы
		Описание остальных переменных доступно в методе List
	*/
	public static function DateList($date,$data,$cnt,$page,$pages,$pp,$links)
	{

	}

	/*
		Страница вывода новостей пользователя (своих)
		$links - массив ссылок, ключи:
			first_page - ссылка на первую страницу пагинатора
			pages - функция-генератор ссылок на остальные страницы
		Описание остальных переменных доступно в методе List
	*/
	public static function MyList($data,$cnt,$page,$pp,$links)
	{

	}

	/*
		Страница вывода новостей определенной категории
		$category - данные категории, массив с ключами:
			id - идентификатор категории
			title - название категории
			description - описание категории
		Описание остальных переменных доступно в методе List
	*/
	public static function CategoryList($category,$data,$cnt,$page,$pp,$links)
	{

	}

	/*
		Страница вывода всех категорий
	*/
	public static function ShowCategories()
	{

	}

	/*
		Страница вывода всех тегов
	*/
	public static function ShowAllTags()
	{

	}

	/*
		Страница вывода новостей за определенную дату
		$data - дата
		$links - массив ссылок, ключи:
			first_page - ссылка на первую страницу пагинатора
			pages - функция-генератор ссылок на остальные страницы
		Описание остальных переменных доступно в методе List
	*/
	public static function TagsList($tag,$data,$cnt,$page,$pages,$pp,$links)
	{

	}

	/*
		Страница поиска новостей
		$values - значение полей поиска формы, массив с ключами:
			text - поисковый запрос
			where - где искать: в заголовке, в заголовке и анонсе, в заголовке, анонсе и тексте (t,ta,tat)
			tags - массив тегов
			categs - массив категорий
			sort - порядок сортировки (date,relevance)
			c - поиск в массиве категорий И или ИЛИ (and,or)
			t - поиск в массиве тегов И или ИЛИ (and,or)
		$error - ошибка, если пустая, значит ошибки нет
		$tags - массив тегов, формат id=>имя тега
		$links - массив ссылок, ключи:
			first_page - ссылка на первую страницу пагинатора
			pages - функция-генератор ссылок на остальные страницы
		Описание остальных переменных доступно в методе List
	*/
	public static function Search($values,$error,$tags,$data,$cnt,$page,$pp,$links)
	{

	}

	/*
		Страница подробного просмотра новости
		$a - массив новости, ключи:
			id - идентификатор новости в БД
			date - дата новости
			author - имя автора новости
			author_id - идентификатор автора новости
			status - статус новости (1 - активна, 0 - заблокирована, -1 - ожидает модерации)
			reads - число просмотров
			comments - число комментариев
			title - заголовок новости
			announcement - анонс новости
			text - подробный текст новости
			_aedit - ссылка на редактирование новости, либо false
			_adel - ссылка на удаление новости, либо false
			_cat - идентификатор основной категории новости
			_sokr - анонс новости
			_tags - массив всех тегов новосоти. Формат: id=>array(), ключи внутреннего массива:
				_a - ссылка на новости данного тега
				tag'=>$temp['name']),true,''),'name'=>$temp['name']);
		$category
			id - идентификатор категории
			title - название категории
			description - описание категории
			_a - ссылка на новости из данной категории
		$voting - HTML опроса новости, либо false
		$comments - HTML комментариев
		$hl - массив слов, которые необходимо подсветить в новости
	*/
	public static function Show($a,$category,$voting,$comments,$hl)
	{

	}

	/*
		Вывод рейтинга новости
		$id - ID новости
		$can - возможность выставить оценку
		$total - число оценок
		$average - средняя оценка
		$sum - сумма всех оценок
		$marks - массив возможных оценок
	*/
	public static function Rating($id,$can,$total,$average,$sum,$marks)
	{

	}
}