<?php
/*
	Copyright © Eleanor CMS
	URL: http://eleanor-cms.ru, http://eleanor-cms.com
	E-mail: support@eleanor-cms.ru
	Developing: Alexander Sunvas*
	Interface: Rumin Sergey
	=====
	*Pseudonym

	Шаблон по умолчанию для админки системного модуля статических страниц
	Рекомендуется скопировать этот файл в templates/[шаблон админки]/Classes/[имя этого файла] и там уже начинать править.
	В случае если такой файл уже существует - правьте его.
*/

class TPLAdminStatic
{
	/*
		Страница отображения всех статических страниц
		$items - массив статических страниц. Формат: ID=>array(), ключи внутреннего массива:
			title - заголовок статической страницы
			pos - целое число, характеризующее позицию статической страницы
			status - статус активности статической страницы
			_aswap - ссылка на включение / выключение активности статической страницы
			_aedit - ссылка на редактирование статической страницы
			_adel - ссылка на удаление статической страницы
			_aparent - ссылка на просмотр подстраниц текущей статической страницы
			_aup - ссылка на поднятие статической страницы вверх, если равна false - значит статическая страница уже и так находится в самом верху
			_adown - ссылка на опускание статической страницы вниз, если равна false - значит статическая страница уже и так находится в самом низу
			_aaddp - ссылка на добавление подстраниц к данной странице
		$subitems - массив статических подстраниц для страниц из массива $items. Фомат: ID=>array(id=>array(), ...), где ID - идентификатор статической страницы, id - идентификатор статической подстраницы. Ключи массива статической подстраницы:
			title - заголовок статической страницы
			_aedit - ссылка на редактирование статической страницы
		$navi - массив, хлебные крошки навигации. Формат ID=>array(), ключи:
			title - заголовок крошки
			_a - ссылка подпункты данной крошки. Может быть равно false
		$cnt - количество статических страниц всего
		$pp - количество статических страниц на страницу
		$qs - массив параметров адресной строки для каждого запроса
		$page - номер текущей страницы, на которой мы сейчас находимся
		$links - перечень необходимых ссылок, массив с ключами:
			sort_status - ссылка на сортировку списка $items по статусу активности (возрастанию/убыванию в зависимости от текущей сортировки)
			sort_title - ссылка на сортировку списка $items по названию (возрастанию/убыванию в зависимости от текущей сортировки)
			sort_pos - ссылка на сортировку списка $items по позиции (возрастанию/убыванию в зависимости от текущей сортировки)
			sort_id - ссылка на сортировку списка $items по ID (возрастанию/убыванию в зависимости от текущей сортировки)
			form_items - ссылка для параметра action формы, внтури которой происходит отображение перечня $items
			pp - фукнция-генератор ссылок на изменение количества статических страниц отображаемых на странице
			first_page - ссылка на первую страницу пагинатора
			pages - функция-генератор ссылок на остальные страницы
	*/
	public static function ShowList($items,$subitems,$navi,$cnt,$pp,$qs,$page,$links)
	{

	}

	/*
		Страница добавления/редактирования статической страницы
		$id - идентификатор редактируемой страницы, если $id==0 значит страница добавляется
		$controls - перечень контролов в соответствии с классом контролов. Если какой-то элемент массива не является массивом, значит это заголовок подгруппы контролов
		$values - результирующий HTML код контролов, который необходимо вывести на странице. Ключи данного массива совпадают с ключами $controls
		$errors - массив ошибок
		$back - URI возврата
		$uploader - интерфейс загрузчика файлов
		$hasdraft - признак того, что у статической страницы есть черновик
		$links - перечень необходимых ссылок, массив с ключами:
			delete - ссылка на удаление статической страницы или false
			nodraft - ссылка на правку/добавление категории без использования черновика или false
			draft - ссылка на сохранение черновиков (для фоновых запросов)
	*/
	public static function AddEdit($id,$controls,$values,$errors,$back,$uploader,$hasdraft,$links)
	{

	}

	/*
		Страница редактирования файлов.
		$files - Uploader
	*/
	public static function Files($files)
	{

	}

	/*
		Страница удаления статической страницы
		$a - массив с информацией о статической странице, ключи
			title - название статической страницы
		$back - URL возврата
	*/
	public static function Delete($a,$back)
	{

	}

	/*
		Обертка для настроек
		$c - интерфейс настроек
	*/
	public static function Options($c)
	{

	}
}